/*
 * CarbX, except for the proprietary licensed third party source code in human
 * and/or machine-readable form, is free software. The third-party source code is
 * not shipped in human and/or machine-readable form along with these source
 * files. If you build CarbX from the provided CarbX source code files while
 * obtaining the required libraries, files and third party source code as well as
 * the required licences on your own, you can redistribute and/or modify the
 * remaining parts of CarbX (i. e. the parts developed by Torben Pfaff) under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version. This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details. You should have received a copy of the GNU Lesser General
 * Public License along with this program. If not, see http://www.gnu.org/licenses/.
 */

//this ile requires "wstp.h" for compilation

#ifndef AUTOFITMATHEMATICA_H
#define AUTOFITMATHEMATICA_H

#include <iostream>  //to use cout for debugging

#include <QFile>
#include <QIODevice>
#include <QString>
#include <QStringList>
#include <QTextStream>

#include "autofitsequence.h"
#include "datastorage.h"
#include "parametersetautofit.h"
#include "settingsstorage.h"

extern "C"{
    #include "wstp.h"
}


class AutoFitMathematica{

private:
    WSENV  env;
    WSLINK link;
    int err;
    int pkt;

public:

    //constructor including initialization of MathLink and definition of required functions within the Mathematica kernel
    AutoFitMathematica(DataStorage *dst, SettingsStorage *sst, short dataThinningFactor);

    //destructor
    ~AutoFitMathematica();

    //shall be overgiven an ParameterSetAutoFit of bad fitted pars, changes the values in this ParameterSetAutoFit
    //needs an AutoFitSequence and the measurement parameter pass-band b
    //closes the MathLink connection when done as class is for one time use
    void autoFit(ParameterSetAutoFit *pars, AutoFitSequence *afseq, int step, QStringList *parsNames, double b, double cN, double cO); //if step > 0 only AutoFitStep no. step will be executed

};

#endif // AUTOFITMATHEMATICA_H
