/*
 * CarbX, except for the proprietary licensed third party source code in human
 * and/or machine-readable form, is free software. The third-party source code is
 * not shipped in human and/or machine-readable form along with these source
 * files. If you build CarbX from the provided CarbX source code files while
 * obtaining the required libraries, files and third party source code as well as
 * the required licences on your own, you can redistribute and/or modify the
 * remaining parts of CarbX (i. e. the parts developed by Torben Pfaff) under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version. This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details. You should have received a copy of the GNU Lesser General
 * Public License along with this program. If not, see http://www.gnu.org/licenses/.
 */

#include "autofitstep.h"

AutoFitStep::AutoFitStep(){
    name = new QString(); //empty string as default
    useStep = true;
    for (int i = 0; i < Enumerations::countOf_parNameAutoFit; ++i){
        autoFitElements[i].autoFit = false;
        autoFitElements[i].min = 0;
        autoFitElements[i].max = 10;
        autoFitElements[i].useMin = true;
        autoFitElements[i].useMax = true;
    }
    additionalConditions = new QStringList();
}

AutoFitStep::~AutoFitStep(){
}

AutoFitStep* AutoFitStep::duplicate(){
    AutoFitStep *duplicate = new AutoFitStep();
    duplicate->name = new QString(*name);
    duplicate->useStep = useStep;
    for (int i = 0; i < Enumerations::countOf_parNameAutoFit; ++i){
        duplicate->autoFitElements[i].autoFit = autoFitElements[i].autoFit;
        duplicate->autoFitElements[i].min = autoFitElements[i].min;
        duplicate->autoFitElements[i].max = autoFitElements[i].max;
        duplicate->autoFitElements[i].useMin = autoFitElements[i].useMin;
        duplicate->autoFitElements[i].useMin = autoFitElements[i].useMin;
    }
    for (int i = 0; i < additionalConditions->size(); ++i)
        duplicate->additionalConditions->append(additionalConditions->at(i));
    return duplicate;
}
