/*
 * CarbX, except for the proprietary licensed third party source code in human
 * and/or machine-readable form, is free software. The third-party source code is
 * not shipped in human and/or machine-readable form along with these source
 * files. If you build CarbX from the provided CarbX source code files while
 * obtaining the required libraries, files and third party source code as well as
 * the required licences on your own, you can redistribute and/or modify the
 * remaining parts of CarbX (i. e. the parts developed by Torben Pfaff) under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version. This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details. You should have received a copy of the GNU Lesser General
 * Public License along with this program. If not, see http://www.gnu.org/licenses/.
 */

#include "dialog_fileconversion.h"
#include "ui_dialog_fileconversion.h"

Dialog_FileConversion::Dialog_FileConversion(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog_FileConversion){

    ui->setupUi(this);

    //own code

    this->setFixedSize(this->width(), this->height());
    this->setWindowFlags(Qt::MSWindowsFixedSizeDialogHint);
    this->setWindowFlags(Qt::CustomizeWindowHint);
    setFocus();

    this->canClose = false;
}

Dialog_FileConversion::~Dialog_FileConversion(){
    delete ui;
}

void Dialog_FileConversion::presetFormats(Enumerations::XFormat XFormat, Enumerations::YFormat YFormat){
    this->XFormat = XFormat;
    this->YFormat = YFormat;

    switch (XFormat){
        case Enumerations::twotheta_degree :
            ui->comboBox_XFormat->setCurrentIndex(0);
            break;
        case Enumerations::s_oneDIVnanometer :
            ui->comboBox_XFormat->setCurrentIndex(1);
            break;
        case Enumerations::s_oneDIVangstrom :
            ui->comboBox_XFormat->setCurrentIndex(2);
            break;
        default :
            break;
    }

    switch (YFormat){
        case Enumerations::linear :
            ui->comboBox_YFormat->setCurrentIndex(0);
            break;
        case Enumerations::log_10 :
            ui->comboBox_YFormat->setCurrentIndex(1);
            break;
        default :
            break;
    }
}

Enumerations::XFormat Dialog_FileConversion::get_XFormat(){
    return XFormat;
}

Enumerations::YFormat Dialog_FileConversion::get_YFormat(){
    return YFormat;
}

void Dialog_FileConversion::on_button_OK_clicked(){
    ui->comboBox_XFormat->setDisabled(true);
    ui->comboBox_YFormat->setDisabled(true);

    switch(ui->comboBox_XFormat->currentIndex()){
        case 0 :
            XFormat = Enumerations::twotheta_degree;
            break;
        case 1 :
            XFormat = Enumerations::s_oneDIVnanometer;
            break;
        case 2 :
            XFormat = Enumerations::s_oneDIVangstrom;
        default :
            break;
    }

    switch (ui->comboBox_YFormat->currentIndex()){
        case 0 :
            YFormat = Enumerations::linear;
            break;
        case 1 :
            YFormat = Enumerations::log_10;
            break;
        default:
            break;
    }

    canClose = true;
    this->close();
}

void Dialog_FileConversion::keyPressEvent(QKeyEvent *event){
    event->accept();
}

void Dialog_FileConversion::closeEvent(QCloseEvent *event){
    if (canClose)
        event->accept();
    else
        event->ignore();
}
