/*
 * CarbX, except for the proprietary licensed third party source code in human
 * and/or machine-readable form, is free software. The third-party source code is
 * not shipped in human and/or machine-readable form along with these source
 * files. If you build CarbX from the provided CarbX source code files while
 * obtaining the required libraries, files and third party source code as well as
 * the required licences on your own, you can redistribute and/or modify the
 * remaining parts of CarbX (i. e. the parts developed by Torben Pfaff) under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version. This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details. You should have received a copy of the GNU Lesser General
 * Public License along with this program. If not, see http://www.gnu.org/licenses/.
 */

#ifndef ENUMERATIONS
#define ENUMERATIONS

class Enumerations{

public:

    //enumerations for pars-array indices
    //do not change numbers!
    //1. index = parName
    //2. index = parType (0:value, 1:minimum, 2:maximum; 3:decrement; 4:increment)
    enum parName        {cno = 0, mu, beta, a3, da3, sig3, u3, eta, nu, alpha, sig1, lcc, q, cN, cO, dan, k, const1, const2, g, mue_ab, p, R, t, countOf_parName};
    enum parNameAutoFit {cnoAF = 0, muAF, betaAF, a3AF, da3AF, sig3AF, u3AF, etaAF, nuAF, alphaAF, sig1AF, lccAF, qAF, danAF, kAF, const1AF, const2AF, gAF, countOf_parNameAutoFit};
    enum parType        {val = 0, min, max, dec, inc, countOf_parType};

    enum drawingOrder {dotsInFront = 0, lineInFront};

    enum XFormat {twotheta_degree = 0 , s_oneDIVnanometer, s_oneDIVangstrom, countOf_XFormat};

    enum YFormat {linear = 0, log_10, countOf_YFormat};

    enum corrPositionMethod {Dz = 0, D2thtx, countOf_corrPositionMethod};

    enum corrIntensityMethod {LambertBeer = 0, Pragmatic, countOf_corrIntensityMethod};

    enum dataToWrite {DataCurve = 0, FitCurve, DeviationCurve, countOf_dataToWrite};

    enum errorType {NoError = 0, DialogCancelled, OtherError, countOf_errorType};

};

#endif // ENUMERATIONS
