/*
 * CarbX, except for the proprietary licensed third party source code in human
 * and/or machine-readable form, is free software. The third-party source code is
 * not shipped in human and/or machine-readable form along with these source
 * files. If you build CarbX from the provided CarbX source code files while
 * obtaining the required libraries, files and third party source code as well as
 * the required licences on your own, you can redistribute and/or modify the
 * remaining parts of CarbX (i. e. the parts developed by Torben Pfaff) under the
 * terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version. This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details. You should have received a copy of the GNU Lesser General
 * Public License along with this program. If not, see http://www.gnu.org/licenses/.
 */

#include "programsettingsset.h"

ProgramSettingsSet::ProgramSettingsSet(QWidget *parentWidget, QObject *parent) : QObject(parent){
    this->parent = parentWidget;

    simpleMode_default = false;
    autoUpdateFit_default = true;
    defaultDir_default = new QString("C:/");
    displayFullPath_default = false;
    adjustAxisIntervals_default = true;
    thicknessOfCurveDots_default = 4;
    thicknessOfCurveLines_default = 2;
    elementInFront_default = Enumerations::lineInFront;
    enableChooseTemplate_default = false;
    calcTemplates_default = false;
    kernelPath_default = new QString("C:/Program Files/Mathematica/math.exe");

    simpleMode = simpleMode_default;
    autoUpdateFit = autoUpdateFit_default;
    defaultDir = new QString(*defaultDir_default);
    displayFullPath = displayFullPath_default;
    adjustAxisIntervals = adjustAxisIntervals_default;
    thicknessOfCurveDots = thicknessOfCurveDots_default;
    thicknessOfCurveLines = thicknessOfCurveLines_default;
    elementInFront = elementInFront_default;
    enableChooseTemplate = enableChooseTemplate_default;
    calcTemplates = calcTemplates_default;
    kernelPath = new QString(*kernelPath_default);
}

ProgramSettingsSet::~ProgramSettingsSet(){
    delete kernelPath;
    delete defaultDir;
    delete kernelPath_default;
    delete defaultDir_default;
}

bool ProgramSettingsSet::get_simpleMode_default(){
    return simpleMode_default;
}

bool ProgramSettingsSet::get_autoUpdateFit_default(){
    return autoUpdateFit_default;
}

QString ProgramSettingsSet::get_defaultDir_default() const{
    return *defaultDir_default;
}

bool ProgramSettingsSet::get_displayFullPath_default(){
    return displayFullPath_default;
}

bool ProgramSettingsSet::get_adjustAxisIntervals_default(){
    return adjustAxisIntervals_default;
}

short ProgramSettingsSet::get_thicknessOfCurveDots_default(){
    return thicknessOfCurveDots_default;
}

short ProgramSettingsSet::get_thicknessOfCurveLines_default(){
    return thicknessOfCurveLines_default;
}

Enumerations::drawingOrder ProgramSettingsSet::get_elementInFront_default(){
    return elementInFront_default;
}

bool ProgramSettingsSet::get_enableChooseTemplate_default(){
    return enableChooseTemplate_default;
}

bool ProgramSettingsSet::get_calcTemplates_default(){
    return calcTemplates_default;
}

QString ProgramSettingsSet::get_kernelPath_default() const{
    return *kernelPath_default;
}
